<?php

	defined('_JEXEC') or die('Direct Access to ' . basename(__FILE__) . ' is not allowed.');

	if(!class_exists('vmPSPlugin')) 
	{
		require(JPATH_VM_PLUGINS . DS . 'vmpsplugin.php');
	}


	// Include iDEAL Checkout library
	require_once(JPATH_ROOT . '/idealcheckout/includes/library.php');


	class plgVMPaymentIdealcheckoutpayconiq extends vmPSPlugin
	{
		// instance of class
		public static $_this = false;

		public function __construct(& $subject, $config)
		{
			parent::__construct($subject, $config);

			$this->_loggable = true;
			$this->tableFields = array_keys($this->getTableSQLFields());

			$varsToPush = array(
'status_pending' => array('P', 'char'), // P=Pending
'status_success' => array('C', 'char'), // C=Confirmed
'status_canceled' => array('X', 'char'), // X=Cancelled
'payment_logos' => array('', 'char'),
'countries' => array(0, 'char'),
'min_amount' => array(0, 'int'),
'max_amount' => array(0, 'int'),
'cost_per_transaction' => array(0, 'int'),
'cost_percent_total' => array(0, 'int'),
'tax_id' => array(0, 'int')
		);

			$this->setConfigParameterable($this->_configTableFieldName, $varsToPush);
		}

		protected function getVmPluginCreateTableSQL()
		{
			return $this->createTableSQL('Payment Idealcheckoutpayconiq Table');
		}

		public function getTableSQLFields()
		{
			$SQLfields = array(
'id' => 'int(11) unsigned NOT NULL AUTO_INCREMENT',
'virtuemart_order_id' => 'int(11) UNSIGNED DEFAULT NULL',
'order_number' => 'char(32) DEFAULT NULL',
'virtuemart_paymentmethod_id' => 'mediumint(1) UNSIGNED DEFAULT NULL',
'payment_name' => 'char(255) NOT NULL DEFAULT \'\'',
'payment_order_total' => 'decimal(15,5) NOT NULL DEFAULT \'0.00000\'',
'payment_currency' => 'char(3)',
'cost_per_transaction' => 'decimal(10,2) DEFAULT NULL',
'cost_percent_total' => 'decimal(10,2) DEFAULT NULL',
'tax_id' => 'smallint(1) DEFAULT NULL',
'idealcheckoutpayconiq_custom' => 'varchar(255)',
		);

		return $SQLfields;
	}

	public function plgVmConfirmedOrder($cart, $order)
	{
		if(!($method = $this->getVmPluginMethod($order['details']['BT']->virtuemart_paymentmethod_id)))
		{
			return null;
		}

		if(!$this->selectedThisElement($method->payment_element))
		{
			return false;
		}

		$session = JFactory::getSession();
		$return_context = $session->getId();

		$this->logInfo('plgVmConfirmedOrder order number: ' . $order['details']['BT']->order_number, 'message');

		if(!class_exists('VirtueMartModelOrders'))
		{
			require(JPATH_VM_ADMINISTRATOR . DS . 'models' . DS . 'orders.php');
		}

		if(!class_exists('VirtueMartModelCurrency'))
		{
			require(JPATH_VM_ADMINISTRATOR . DS . 'models' . DS . 'currency.php');
		}

		$new_status = '';

		$usrBT = $order['details']['BT'];
		$address = ((isset($order['details']['ST'])) ? $order['details']['ST'] : $order['details']['BT']);

		$vendorModel = new VirtueMartModelVendor();
		$vendorModel->setId(1);
		$vendor = $vendorModel->getVendor();
		$this->getPaymentCurrency($method);

		$q = 'SELECT `currency_code_3` FROM `#__virtuemart_currencies` WHERE `virtuemart_currency_id`="' . $method->payment_currency . '" ';
		$db = &JFactory::getDBO();
		$db->setQuery($q);
		$currency_code_3 = $db->loadResult();

		$paymentCurrency = CurrencyDisplay::getInstance($method->payment_currency);
		$totalInPaymentCurrency = round($paymentCurrency->convertCurrencyTo($method->payment_currency, $order['details']['BT']->order_total,false), 2);
		$cd = CurrencyDisplay::getInstance($cart->pricesCurrency);


		// Prepare data that should be stored in the database
		$dbValues = array();
		$dbValues['order_number'] = $order['details']['BT']->order_number;
		$dbValues['payment_name'] = $this->renderPluginName($method, $order);
		$dbValues['virtuemart_paymentmethod_id'] = $cart->virtuemart_paymentmethod_id;
		$dbValues['idealcheckoutpayconiq_custom'] = $return_context;
		$dbValues['cost_per_transaction'] = $method->cost_per_transaction;
		$dbValues['cost_percent_total'] = $method->cost_percent_total;
		$dbValues['payment_currency'] = $method->payment_currency;
		$dbValues['payment_order_total'] = $totalInPaymentCurrency;
		$dbValues['tax_id'] = $method->tax_id;
		$this->storePSPluginInternalData($dbValues);



		// Load database settings
		$aDatabaseSettings = idealcheckout_getDatabaseSettings();

		$sStoreCode = idealcheckout_getStoreCode();
		$sGatewayCode = 'payconiq';
		$sLanguageCode = $this->_getLanguageCode(); // nl, de, en
		$sCountryCode = '';
		$sCurrencyCode = 'EUR'; // $currency_code_3


		$sOrderId = $order['details']['BT']->order_number;
		$sOrderCode = idealcheckout_getRandomCode(32);
		$aOrderParams = array();
		$sTransactionId = idealcheckout_getRandomCode(32);
		$sTransactionCode = idealcheckout_getRandomCode(32);
		$fTransactionAmount = $totalInPaymentCurrency;

		$sTransactionDescription = idealcheckout_getTranslation($sLanguageCode, 'idealcheckout', 'Webshop order #{0}', array($sOrderId));
		$sTransactionPaymentUrl = JROUTE::_(JURI::root() . 'index.php?option=com_virtuemart&view=pluginresponse&task=pluginUserPaymentCancel&on=' . $sOrderId . '&pm=' . $order['details']['BT']->virtuemart_paymentmethod_id);
		$sTransactionSuccessUrl = JROUTE::_(JURI::root() . 'index.php?option=com_virtuemart&view=pluginresponse&task=pluginresponsereceived&pm=' . $order['details']['BT']->virtuemart_paymentmethod_id . '&order_id=' . $sOrderId . '&order_code=' . $sOrderCode);
		$sTransactionPendingUrl = JROUTE::_(JURI::root() . 'index.php?option=com_virtuemart&view=pluginresponse&task=pluginresponsereceived&pm=' . $order['details']['BT']->virtuemart_paymentmethod_id . '&order_id=' . $sOrderId . '&order_code=' . $sOrderCode);
		$sTransactionFailureUrl = JROUTE::_(JURI::root() . 'index.php?option=com_virtuemart&view=pluginresponse&task=pluginUserPaymentCancel&on=' . $sOrderId . '&pm=' . $order['details']['BT']->virtuemart_paymentmethod_id);


		// Store ORDER information
		$aOrderParams['order'] = array(
			'id' => $sOrderId,
			'amount' => $fTransactionAmount,
		);

		$aOrderParams['contact'] = array(
			'first_name' => $address->first_name, 
			'last_name' => $address->last_name, 
			'address1' => $address->address_1, 
			'address2' => (isset($address->address_2) ? $address->address_2 : ''), 
			'zip' => $address->zip, 
			'city' => $address->city, 
			'country' => ShopFunctions::getCountryByID($address->virtuemart_country_id, 'country_3_code'), 
			'email' => $address->email, 
			'phone' => $address->phone_1, 
		);

		$aOrderParams['status'] = array(
			'success' => $method->status_success,
			'pending' => $method->status_pending,
			'cancelled' => $method->status_canceled,
		);



		$oShipmentAddress = ((isset($order['details']['ST'])) ? $order['details']['ST'] : $order['details']['BT']);
		$oBillingAddress = ((isset($order['details']['BT'])) ? $order['details']['BT'] : $order['details']['ST']);

		$aOrderParams['customer'] = array();

		// Shipment data
		list($sStreetName, $sStreetNumber, $sExtension) = idealcheckout_mb_splitAddress($oShipmentAddress->address_1 . ' ' . $oShipmentAddress->address_2);

		$sCountryCode = ShopFunctions::getCountryByID($oShipmentAddress->virtuemart_country_id, 'country_3_code');
		$sCountryCode = ((strcasecmp($sCountryCode, 'BEL') === 0) ? 'BE' : 'NL');
		$sCountryName = ((strcasecmp($sCountryCode, 'BE') === 0) ? 'Belgie' : 'Nederland');

		$aOrderParams['customer']['shipment_company'] = '';
		$aOrderParams['customer']['shipment_name'] = $oShipmentAddress->first_name . ' ' . $oShipmentAddress->last_name;
		$aOrderParams['customer']['shipment_first_name'] = $oShipmentAddress->first_name;
		$aOrderParams['customer']['shipment_last_name'] = $oShipmentAddress->last_name;
		$aOrderParams['customer']['shipment_gender'] = '';
		$aOrderParams['customer']['shipment_date_of_birth'] = '';
		$aOrderParams['customer']['shipment_phone'] = $oShipmentAddress->phone_1;
		$aOrderParams['customer']['shipment_email'] = $oShipmentAddress->email;
		$aOrderParams['customer']['shipment_address'] = $oShipmentAddress->address_1 . (empty($oShipmentAddress->address_2) ? '' : ', ' . $oShipmentAddress->address_2);
		$aOrderParams['customer']['shipment_street_name'] = $sStreetName;
		$aOrderParams['customer']['shipment_street_number'] = $sStreetNumber;
		$aOrderParams['customer']['shipment_street_number_extension'] = $sExtension;
		$aOrderParams['customer']['shipment_zipcode'] = $oShipmentAddress->zip;
		$aOrderParams['customer']['shipment_city'] = $oShipmentAddress->city;
		$aOrderParams['customer']['shipment_country_code'] = $sCountryCode;
		$aOrderParams['customer']['shipment_country_name'] = $sCountryName;


		// Payment data
		list($sStreetName, $sStreetNumber, $sExtension) = idealcheckout_mb_splitAddress($oBillingAddress->address_1 . ' ' . $oBillingAddress->address_2);

		$sCountryCode = ShopFunctions::getCountryByID($oBillingAddress->virtuemart_country_id, 'country_3_code');
		$sCountryCode = ((strcasecmp($sCountryCode, 'BEL') === 0) ? 'BE' : 'NL');
		$sCountryName = ((strcasecmp($sCountryCode, 'BE') === 0) ? 'Belgie' : 'Nederland');

		$aOrderParams['customer']['payment_company'] = '';
		$aOrderParams['customer']['payment_name'] = $oBillingAddress->first_name . ' ' . $oBillingAddress->last_name;
		$aOrderParams['customer']['payment_first_name'] = $oBillingAddress->first_name;
		$aOrderParams['customer']['payment_last_name'] = $oBillingAddress->last_name;
		$aOrderParams['customer']['payment_gender'] = '';
		$aOrderParams['customer']['payment_date_of_birth'] = '';
		$aOrderParams['customer']['payment_phone'] = $oBillingAddress->phone_1;
		$aOrderParams['customer']['payment_email'] = $oBillingAddress->email;
		$aOrderParams['customer']['payment_address'] = $oBillingAddress->address_1 . (empty($oBillingAddress->address_2) ? '' : ', ' . $oBillingAddress->address_2);
		$aOrderParams['customer']['payment_street_name'] = $sStreetName;
		$aOrderParams['customer']['payment_street_number'] = $sStreetNumber;
		$aOrderParams['customer']['payment_street_number_extension'] = $sExtension;
		$aOrderParams['customer']['payment_zipcode'] = $oBillingAddress->zip;
		$aOrderParams['customer']['payment_city'] = $oBillingAddress->city;
		$aOrderParams['customer']['payment_country_code'] = $sCountryCode;
		$aOrderParams['customer']['payment_country_name'] = $sCountryName;


		$aOrderParams['products'] = array();
		$aOrderParams['products'][] = array('code' => $sOrderId, 'description' => $sTransactionDescription, 'quantity' => 1, 'price_incl' => $fTransactionAmount, 'price_excl' => $fTransactionAmount, 'vat' => 0);






		// Insert data into idealcheckout-table
		$sql = "INSERT INTO `" . $aDatabaseSettings['table'] . "` SET 
`id` = NULL, 
`order_id` = '" . idealcheckout_escapeSql($sOrderId) . "', 
`order_code` = '" . idealcheckout_escapeSql($sOrderCode) . "', 
`order_params` = '" . idealcheckout_escapeSql(idealcheckout_serialize($aOrderParams)) . "', 
`store_code` = " . (empty($sStoreCode) ? "NULL" : "'" . idealcheckout_escapeSql($sStoreCode) . "'") . ", 
`gateway_code` = '" . idealcheckout_escapeSql($sGatewayCode) . "', 
`language_code` = " . (empty($sLanguageCode) ? "NULL" : "'" . idealcheckout_escapeSql($sLanguageCode) . "'") . ", 
`country_code` = " . (empty($sCountryCode) ? "NULL" : "'" . idealcheckout_escapeSql($sCountryCode) . "'") . ", 
`currency_code` = '" . idealcheckout_escapeSql($sCurrencyCode) . "', 
`transaction_id` = '" . idealcheckout_escapeSql($sTransactionId) . "', 
`transaction_code` = '" . idealcheckout_escapeSql($sTransactionCode) . "', 
`transaction_params` = NULL, 
`transaction_date` = '" . idealcheckout_escapeSql(time()) . "', 
`transaction_amount` = '" . idealcheckout_escapeSql($fTransactionAmount) . "', 
`transaction_description` = '" . idealcheckout_escapeSql($sTransactionDescription) . "', 
`transaction_status` = NULL, 
`transaction_url` = NULL, 
`transaction_payment_url` = '" . idealcheckout_escapeSql($sTransactionPaymentUrl) . "', 
`transaction_success_url` = '" . idealcheckout_escapeSql($sTransactionSuccessUrl) . "', 
`transaction_pending_url` = '" . idealcheckout_escapeSql($sTransactionPendingUrl) . "', 
`transaction_failure_url` = '" . idealcheckout_escapeSql($sTransactionFailureUrl) . "', 
`transaction_log` = NULL;";


		// Add record to transaction table
		$db = JFactory::getDBO();
		$db->setQuery($sql);
		$db->query();
		// $iInsertId = $db->insertid();

		$html = '<form action="' . (JURI::root() . 'idealcheckout/setup.php?order_id=' . $sOrderId . '&order_code=' . $sOrderCode) . '" method="post" name="vm_idealcheckoutpayconiq_form" id="vm_idealcheckoutpayconiq_form"><input type="submit" value="Afrekenen met Payconiq" /></form>';
		$html .= '<script type="text/javascript"> setTimeout(\'doSubmit()\', 100); function doSubmit(){document.vm_idealcheckoutpayconiq_form.submit();}</script>';

		// 	2 = don't delete the cart, don't send email and don't redirect
		return $this->processConfirmedOrderPaymentResponse(2, $cart, $order, $html, $new_status);
	}


	public function plgVmgetPaymentCurrency($virtuemart_paymentmethod_id, &$paymentCurrencyId)
	{
		if(!($method = $this->getVmPluginMethod($virtuemart_paymentmethod_id)))
		{
			return null; // Another method was selected, do nothing
		}

		if(!$this->selectedThisElement($method->payment_element))
		{
			return false;
		}

		$this->getPaymentCurrency($method);
		$paymentCurrencyId = $method->payment_currency;
	}

	public function plgVmOnPaymentResponseReceived(&$html)
	{
		$virtuemart_paymentmethod_id = JRequest::getInt('pm', 0);
		$vendorId = 0;

		if(!($method = $this->getVmPluginMethod($virtuemart_paymentmethod_id)))
		{
			return null;
		}

		if(!$this->selectedThisElement($method->payment_element))
		{
			return false;
		}


		$order_number = JRequest::getVar('order_id');
		$order_code = JRequest::getVar('order_code');

		$aDatabaseSettings = idealcheckout_getDatabaseSettings();
		$sql = "SELECT * FROM `" . $aDatabaseSettings['table'] . "` WHERE (`order_id` = '" . idealcheckout_escapeSql($order_number) . "') AND (`order_code` = '" . idealcheckout_escapeSql($order_code) . "') LIMIT 1;";

		$db = JFactory::getDBO();
		$db->setQuery($sql);
		$result = $db->loadObject();

		if($result)
		{
			if(!class_exists('VirtueMartModelOrders'))
			{
				require(JPATH_VM_ADMINISTRATOR . DS . 'models' . DS . 'orders.php');
			}

			$virtuemart_order_id = VirtueMartModelOrders::getOrderIdByOrderNumber($order_number);
			$payment_name = $this->renderPluginName($method);

			if($virtuemart_order_id)
			{
				if(!class_exists('VirtueMartCart'))
				{
					require(JPATH_VM_SITE . DS . 'helpers' . DS . 'cart.php');
				}

				// get the correct cart / session
				$cart = VirtueMartCart::getCart();

				// send the email ONLY if payment has been accepted
				if(!class_exists('VirtueMartModelOrders'))
				{
					require(JPATH_VM_ADMINISTRATOR . DS . 'models' . DS . 'orders.php' );
				}


				$sLanguageCode = $this->_getLanguageCode();

				if(strcasecmp($result->transaction_status, 'SUCCESS') === 0)
				{
					$html .= idealcheckout_getTranslation($sLanguageCode, 'virtuemart', 'PAYMENT_SUCCESS', array('order' => $result->order_id, 'amount' => number_format($result->transaction_amount, 2, ',', '')));

					$oModelOrder = new VirtueMartModelOrders();
					$oOrder = $oModelOrder->getOrder($virtuemart_order_id);
					$currentStatus = $oOrder['details']['BT']->order_status;

					if(method_exists($cart, 'sentOrderConfirmedEmail'))
					{
						$cart->sentOrderConfirmedEmail($oOrder);
					}
					elseif((method_exists($oModelOrder, 'updateStatusForOneOrder')) && (!in_array($currentStatus, array('C', 'S'))))
					{
						$aOrder = array();
						$aOrder['order_status'] = 'C';
						$aOrder['virtuemart_order_id'] = $virtuemart_order_id;
						$aOrder['customer_notified'] = 1;

						$date = JFactory::getDate();
						$aOrder['comments'] = ('Transaction status recieved from PSP: ' . $result->transaction_status);

						$oModelOrder->updateStatusForOneOrder($virtuemart_order_id, $aOrder, true);
					}

					$cart->emptyCart();
				}
				elseif(strcasecmp($result->transaction_status, 'PENDING') === 0)
				{
					$html .= idealcheckout_getTranslation($sLanguageCode, 'virtuemart', 'PAYMENT_PENDING', array('order' => $result->order_id, 'amount' => number_format($result->transaction_amount, 2, ',', '')));
				}
				else
				{
					$html .= idealcheckout_getTranslation($sLanguageCode, 'virtuemart', 'PAYMENT_FAILURE', array('order' => $result->order_id, 'amount' => number_format($result->transaction_amount, 2, ',', '')));
				}
			}
		}

		return true;
	}


	public function plgVmOnUserPaymentCancel()
	{
		if(!class_exists('VirtueMartModelOrders'))
		{
			require(JPATH_VM_ADMINISTRATOR . DS . 'models' . DS . 'orders.php');
		}

		if(!$this->isCurrentPaymentmethod('idealcheckoutpayconiq'))
		{
			return null;
		}

		$order_number = JRequest::getVar('on');

		if(!$order_number)
		{
			return false;
		}

		$db = JFactory::getDBO();
		$query = 'SELECT ' . $this->_tablename . '.`virtuemart_order_id` FROM ' . $this->_tablename. " WHERE  `order_number`= '" . $order_number . "'";
		$db->setQuery($query);
		$virtuemart_order_id = $db->loadResult();

		if(!$virtuemart_order_id)
		{
			return null;
		}

		$this->handlePaymentUserCancel($virtuemart_order_id);

		return true;
	}

	public function plgVmOnPaymentNotification()
	{
		return null;
	}

	public function plgVmOnShowOrderBEPayment($virtuemart_order_id, $payment_method_id)
	{
		if(!$this->selectedThisByMethodId($payment_method_id))
		{
			return null;
		}

		$db = JFactory::getDBO();
		$q = "SELECT * FROM `" . $this->_tablename . "` WHERE `virtuemart_order_id` = '" . $virtuemart_order_id . "'";
		$db->setQuery($q);

		if(!($paymentTable = $db->loadObject()))
		{
			return '';
		}

		$this->getPaymentCurrency($paymentTable);

		$q = 'SELECT `currency_code_3` FROM `#__virtuemart_currencies` WHERE `virtuemart_currency_id`="' . $paymentTable->payment_currency . '" ';
		$db = &JFactory::getDBO();
		$db->setQuery($q);
		$currency_code_3 = $db->loadResult();

		$html = '<table class="adminlist">' . "\n";
		$html .= $this->getHtmlHeaderBE();
		$html .= $this->getHtmlRowBE('IDEALCHECKOUTPAYCONIQ_PAYMENT_NAME', $paymentTable->payment_name);
		//$html .= $this->getHtmlRowBE('IDEALCHECKOUTPAYCONIQ_PAYMENT_TOTAL_CURRENCY', $paymentTable->payment_order_total.' '.$currency_code_3);

		$code = "idealcheckoutpayconiq_response_";

		foreach($paymentTable as $key => $value)
		{
			if(substr($key, 0, strlen($code)) == $code)
			{
				$html .= $this->getHtmlRowBE($key, $value);
			}
		}

		$html .= '</table>' . "\n";

		return $html;
	}

	public function getCosts(VirtueMartCart $cart, $method, $cart_prices)
	{
		if(preg_match('/%$/', $method->cost_percent_total))
		{
			$cost_percent_total = substr($method->cost_percent_total, 0, -1);
		}
		else
		{
			$cost_percent_total = $method->cost_percent_total;
		}

		return round($method->cost_per_transaction + ($cart_prices['salesPrice'] * $cost_percent_total * 0.01), 2);
	}

	protected function checkConditions($cart, $method, $cart_prices)
	{
		$address = (($cart->ST == 0) ? $cart->BT : $cart->ST);

		$amount = $cart_prices['salesPrice'];
		$amount_cond = ((($amount >= $method->min_amount) AND ($amount <= $method->max_amount)) OR (($method->min_amount <= $amount) AND ($method->max_amount == 0)));

		$countries = array();

		if(!empty($method->countries))
		{
			if(!is_array($method->countries))
			{
				$countries[0] = $method->countries;
			}
			else
			{
				$countries = $method->countries;
			}
		}

		if(!is_array($address))
		{
			$address = array();
			$address['virtuemart_country_id'] = 0;
		}

		if(!isset($address['virtuemart_country_id']))
		{
			$address['virtuemart_country_id'] = 0;
		}

		if(in_array($address['virtuemart_country_id'], $countries) || count($countries) == 0)
		{
			if($amount_cond)
			{
				return true;
			}
		}

		return false;
	}

	public function plgVmOnStoreInstallPaymentPluginTable($jplugin_id)
	{
		return $this->onStoreInstallPluginTable($jplugin_id);
	}

	public function plgVmOnSelectCheckPayment(VirtueMartCart $cart)
	{
		return $this->OnSelectCheck($cart);
	}

	public function plgVmDisplayListFEPayment(VirtueMartCart $cart, $selected = 0, &$htmlIn)
	{
		return $this->displayListFE($cart, $selected, $htmlIn);
	}

	public function plgVmonSelectedCalculatePricePayment(VirtueMartCart $cart, array &$cart_prices, &$cart_prices_name)
	{
		return $this->onSelectedCalculatePrice($cart, $cart_prices, $cart_prices_name);
	}

	public function plgVmOnCheckAutomaticSelectedPayment(VirtueMartCart $cart, array $cart_prices = array())
	{
		return $this->onCheckAutomaticSelected($cart, $cart_prices);
	}

	public function plgVmOnShowOrderFEPayment($virtuemart_order_id, $virtuemart_paymentmethod_id, &$payment_name)
	{
		$this->onShowOrderFE($virtuemart_order_id, $virtuemart_paymentmethod_id, $payment_name);
	}

	public function plgVmonShowOrderPrintPayment($order_number, $method_id)
	{
		return $this->onShowOrderPrint($order_number, $method_id);
	}

	public function plgVmDeclarePluginParamsPayment($name, $id, &$data)
	{
		return $this->declarePluginParams('payment', $name, $id, $data);
	}

	public function plgVmSetOnTablePluginParamsPayment($name, $id, &$table)
	{
		return $this->setOnTablePluginParams($name, $id, $table);
	}

	private function _getLanguageCode()
	{
		return 'nl';
	}
	
	public function isCurrentPaymentmethod($sCurrentPaymentmethod)
	{
		global $sIdealcheckoutCurrentPaymentmethod;
		
		$virtuemart_paymentmethod_id = JRequest::getInt('pm', 0);
		if($virtuemart_paymentmethod_id > 0)
		{
			if(!isset($sIdealcheckoutCurrentPaymentmethod))
			{
				$sIdealcheckoutCurrentPaymentmethod = '';
				$aDatabaseSettings = idealcheckout_getDatabaseSettings();
				$sql = "SELECT `payment_element` FROM `" . $aDatabaseSettings['prefix'] . "virtuemart_paymentmethods` WHERE (`virtuemart_paymentmethod_id` = '" . $virtuemart_paymentmethod_id . "') LIMIT 1";
				$aRecord = idealcheckout_database_getRecord($sql);
				
				if($aRecord)
				{
					$sIdealcheckoutCurrentPaymentmethod = $aRecord['payment_element'];
				}
			}
			
			if(strcasecmp($sIdealcheckoutCurrentPaymentmethod, $sCurrentPaymentmethod) === 0)
			{
				return true;
			}
		}
		
		return false;
	}
}
